/*
Copyright 2017-2025 Ian Jauslin

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

#include <math.h>
#include "int_tools.h"

// return smallest power of 2 that is > x
int smallest_pow2(
  int x
){
  return ipow(2,((int)log2(x)+1));
}

// integer power
int ipow(
  int x,
  int n
){
  int out=1;
  while (n>0)
  {
    if (n%2==1){
      out*=x; 
    }
    n/=2;
    x*=x;
  }
  return out;
}
